#include <stdio.h>
#include <math.h>

struct complexe
{
  float reel;
  float imag;
};
typedef struct complexe complexe;

void print_complexe(complexe z)
{
  if (z.imag >= 0)
  {
    printf("%f + %f*i", z.reel, z.imag);
  }
  else
  {
    printf("%f - %f*i", z.reel, -z.imag);
  }
}

complexe add(complexe z1, complexe z2)
{
  complexe z;
  z.reel = z1.reel + z2.reel;
  z.imag = z1.imag + z2.imag;
  return z;
}

complexe m_const(complexe z, float a)
{
  complexe res;
  res.reel = a * z.reel;
  res.imag = a * z.imag;
  return res;
}

complexe soustract(complexe z1, complexe z2)
{
  return add(z1, m_const(z2, -1.0));
}

complexe prod(complexe z1, complexe z2)
{
  complexe z;
  z.reel = z1.reel * z2.reel - z1.imag * z2.imag;
  z.imag = z1.reel * z2.imag + z1.imag * z2.reel;
  return z;
}

float module(complexe z)
{
  return sqrt(z.reel * z.reel + z.imag * z.imag);
}

complexe conjug(complexe z)
{
  complexe z_bar = z;
  z_bar.imag *= -1;
  return z_bar;
}

complexe div(complexe z1, complexe z2)
{
  float m2 = module(z2);
  complexe p = prod(z1, conjug(z2));
  return m_const(p, 1/(m2*m2));
}

int main()
{
  complexe z1 = { 1.0, 1.0 };
  complexe z2 = { 2.0, 3.0 };
  printf("z1 = ");
  print_complexe(z1);
  printf(" ; z2 = ");
  print_complexe(z2);
  printf("\n");
  printf("z1 * z2 = ");
  print_complexe(prod(z1, z2));
  printf("\n");
  printf("z1 / z2 = ");
  print_complexe(div(z1, z2));
  printf("\n");
}
