#include<stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <time.h>

bool **star42(int n)
{
  bool **know = (bool **)malloc(n * sizeof(bool *));
  for (int i = 0; i < n; i++)
  {
    know[i] = (bool *)malloc(n * sizeof(bool));
  }
  for (int i = 0; i < n; i++)
  {
    if (i == 42)
    {
      continue;
    }
    for (int j = 0; j < n; j++)
    {
      if (i == j)
      {
        know[i][j] = false;
      }
      else if (j == 42)
      {
        know[i][j] = true;
      }
      else
      {
        know[i][j] = (rand()%2 == 0);
      }
    }
  }
  return know;
}

int star(bool **know, int n)
{
  int star = 0;
  // On cherche quelqu'un qui ne connait personne
  for (int i = 0; i < n; i++)
  {
    bool is_star = true;
    for (int j = 0; j < n; j++)
    {
      if (know[i][j])
      {
        is_star = false;
        break;
      }
    }
    if (is_star)
    {
      star = i;
      break; // la seule star possible est i
    }
  }
  for (int i = 0; i < n; i++)
  {
    if (i != star && !know[i][star])
    {
      return -1; // pas de star
    }
  }
  return star; // on a trouvé la star
}
 int star_lineaire(bool **know, int n)
{
  int a = 0, b = n-1;
  for (int i = 0; i < n; i++)
  {
    if (know[a][b]) // a n'est pas la star
    {
      a++;
    }
    else // b n'est pas la star
    {
      b--;
    }
  }
  /* Quand on arrive ici, on a forcément a==b,
     et c'est la seule star possible */
  int star = a;
  // On vérifie que la star ne connait personne
  for (int i = 0; i < n; i++)
  {
    if (know[star][i])
    {
      return -1; // ce n'est pas la star
    }
  }
  // On vérifie que tout le monde connait la star
  for (int i = 0; i < n; i++)
  {
    if (i != star && !know[i][star])
    {
      return -1; // ce n'est pas la star
    }
  }
  return star; // on a trouvé la star
}

int main()
{
  srand(time(NULL)); // initialise la seed de rand
  int n = 50;
  bool **know = star42(n);
  printf("La star est : %d\n", star(know, n));
  // printf("La star est : %d\n", star_lineaire(know, n));
  free(know);
  return EXIT_SUCCESS;
}
