#include<sys/time.h>
#include<stdio.h>
#include <stdlib.h>

float moyenne(float *tab, int n)
{
  float somme = 0.0;
  for (int i = 0; i < n; i++)
  {
    somme += tab[i];
  }
  return somme / n;
}

float variance_v1(float *tab, int n)
{
  float v = 0.0;
  for (int i = 0; i < n; i++)
  {
    float f = tab[i] - moyenne(tab, n);
    v += f * f;
  }
  return v / n;
}

float variance_v2(float *tab, int n)
{
  float v = 0.0;
  float m = moyenne(tab, n);
  for (int i = 0; i < n; i++)
  {
    float f = tab[i] - m;
    v += f * f;
  }
  return v / n;
}

int main()
{
  int n = 1000;
  float *tab = malloc(n * sizeof(float));
  struct timeval t1, t2;
  gettimeofday(&t1, NULL);

  moyenne(tab, n);
  // variance_v1(tab, n);
  // variance_v2(tab, n);

  gettimeofday(&t2, NULL);
  printf("Temps d'exécution : %lu microsecondes\n",t2.tv_usec - t1.tv_usec);
  free(tab);
  return EXIT_SUCCESS;
}
