#include<stdio.h>
#include <stdlib.h>
#include <stdbool.h>

void echange(int *tab, int i, int j)
{
  int tmp = tab[i];
  tab[i] = tab[j];
  tab[j] = tmp;
}

/* Notation :
   tab[i:j] désigne le sous-tableau entre les indices
   i inclus et j exclu */


void tri_bulle(int *tab, int n)
{
  int p = n;
  bool pastrie = true;
  while (pastrie)
  {
    pastrie = false;
    for (int i = 0; i < p-1; i++)
    {
      if (tab[i] > tab[i+1])
      {
        echange(tab, i , i+1);
        pastrie = true;
      }
    }
    p--;
  }
}

/* Invariant de la boucle for (interne) :
   Inv(i) : tab[i] est plus grand que tous les éléments de tab[0:i]
*/

/* Invariant de la boucle while :
   1) tab[p:n] est trié
   2) les éléments de tab[p:n] sont plus grands
      que les éléments de tab[0:p]
   3) pastrie == true ou tab[0:p] est trié
*/

void tri_insertion(int *tab, int n)
{
  for (int i = 1; i < n; i++)
  {
    int j = i;
    int x = tab[i];
    while (j>0 && tab[j-1]>x)
    {
      tab[j] = tab[j-1];
      j--;
    }
    tab[j] = x;
  }
}

/* Invariant de la boucle while :
   Pour tout k vérifiant j < k <= i, on a tab[k] > x
*/

/* Invariant de la boucle for (externe) :
   Inv(i) : tab[0:i] est trié
*/

void print_tab(int *tab, int n)
{
  for (int i = 0; i < n; i++)
  {
    printf("%d ", tab[i]);
  }
  printf("\n");
}

int main()
{
  int tab[] = {12, 0, 42, 25, 100, 5, 64};
  int n = 7;
  tri_bulle(tab, n);
  // tri_insertion(tab, n);
  print_tab(tab, n);
  return EXIT_SUCCESS;
}
